class DuplicatingError(Exception):
    pass

class NonExistentError(Exception):
    pass

class StudentNotFoundError(NonExistentError):
    pass

class StudentAlreadyExistsError(DuplicatingError):
    pass

class AssignmentNotFoundError(NonExistentError):
    pass

class AssignmentAlreadyExistsError(DuplicatingError):
    pass

class GradeNotFoundError(NonExistentError):
    pass

class GradeAlreadyExistsError(DuplicatingError):
    pass

class GradeValueAlreadySetError(DuplicatingError):
    pass